package com.jln.common.utils;


import com.jln.common.RedisUtil.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

/**
 * <p>
 *
 * </p>
 *
 * @author 龙明普
 * @version 1.0
 * @date 2020/9/6 13:04
 */
@Component
public class UniqueIdGenerator {

    @Autowired
    private RedisUtil redisUtil;

    private static UniqueIdGenerator instance;
    //当前节点的唯一标识
    //private static String uuid;
    //redis号段的key
    private static String redisKey = "UniqueIdGenerator:";
    //起始号段
    private long sectionStart = -1;
    //最大编号
    private int sectionNum = 1000;
    //当前编号
    private int usedNum = -1;

    private UniqueIdGenerator() {
    }

    @PostConstruct
    public void init() {
        instance = this;
        instance.redisUtil = this.redisUtil;
    }

    public static synchronized UniqueIdGenerator getInstance() {
        if (instance == null) {
            instance = new UniqueIdGenerator();
            //uuid = UUIDHexGenerator.generate();
        }
        return instance;
    }

    /**
     * 获取唯一id
     * @param redisUtil redis实例,因为无法在工具类里面引用,需要在外面传参
     * @param name redis key的名称,用于支持不同表的id生成
     * @return
     */
    public long  genUniqueId(String name) {
        synchronized(UniqueIdGenerator.class){
            if (usedNum == -1 || usedNum >= sectionNum) {
                //从redis获取号码段的起始值和号码段的长度, 此数据需要redis存起来，保证不能丢失
                if(EmptyUtil.isEmpty(redisUtil.get(redisKey+name))){
                    //redis没有初始化过号段,开始初始化(此步骤需要走数据库获取数据)
                    redisUtil.set(redisKey+name,0);
                }
                //每次取1000号段
                sectionStart = redisUtil.incr(redisKey+name,sectionNum);
                usedNum = 0;
            }
            return sectionStart + usedNum++;
        }

    }
}
