package com.jln.system.web.action.mqtt;

import com.alibaba.fastjson.JSONObject;
import com.jln.common.utils.EmptyUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;

@Slf4j
@Component
public class Base64decrypt {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Value("${jugeTime}")
    private Long jugeTime;

    @Value("${sleepTime}")
    private Long sleepTime;


    private Map<String,Object> findMongo( Map<String,Map<String,Object>> tableFiels ) {
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        Map<String,Object> map = null;

        for (Map.Entry<String,Map<String,Object>> entry : tableFiels.entrySet()) {
            //System.out.println("key = " + entry.getKey() + ", value = " + entry.getValue());
            //新建一个query对象
            Query query = new Query();
            for (Map.Entry<String,Object> fields : entry.getValue().entrySet()){
                query.fields().include(fields.getKey());
            }
            query.fields().include("time");
            query.limit(1);
            query.with(Sort.by(
                    Sort.Order.desc("time")
            ));
            List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, entry.getKey()+yearMonth);
            //mongdb最新数据时间
            Map<String ,Object> map1 = objectList.get(0).toJavaObject(Map.class);

            Set<Map.Entry<String, Object>> entries = entry.getValue().entrySet();//key 是 数据库字段，value 是iot
            //处理上报的字段



            Long time = Long.valueOf(map1.get("time").toString());
            //当前时间
            long millis = Calendar.getInstance().getTimeInMillis();
            //如果当前时间-最新上报数据的时间<设置关机范围，那么直接给
            if ((millis - time) < jugeTime && !ObjectUtils.isEmpty(objectList)) {
                JSONObject jsonObject = objectList.get(0);
                if(!EmptyUtil.isEmpty(map)){
                    jsonObject.toJavaObject(Map.class);
                    map.putAll(jsonObject.toJavaObject(Map.class));
                }else{
                    map = jsonObject.toJavaObject(Map.class);
                }
            }
            for (Map.Entry<String,Object> fields : entry.getValue().entrySet()){//
                boolean contains = map.containsKey(fields.getKey());
                if(contains){
                    Object valeDb = map.get(fields.getKey());
                    map.remove(fields.getKey()) ;
                    map.put(fields.getValue().toString(),valeDb);
                }
            }
        }



       return  map;
    }

    private Map findMongo1(String deviceId,int start,int end) {
        int i = (int)Math.ceil((double) start/50);
        int j =(int) Math.ceil((double) end/50);

        System.out.println();
        String tableName = "";
        Map map = null;
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        for(int x = i; x<=j; x++){
            try {
                if(x<10){
                    tableName = deviceId + "0" +x + yearMonth;
                }else{
                    tableName = deviceId + x + yearMonth;
                }
                //从mongodb查询
                Query query = new Query();
                query.limit(1);
                query.with(Sort.by(
                        Sort.Order.desc("time")
                ));
                if(x==j){
                    for (int a=start;a<=end;a++){
                        query.fields().include("d"+a);
                    }
                }else{
                    for (int a=start;a<=x*50;a++){
                        query.fields().include("d"+a);
                    }
                }
                query.fields().include("time");
                List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, tableName);
                //mongdb最新数据时间
                Long time = Long.valueOf(objectList.get(0).toJavaObject(Map.class).get("time").toString());
                //当前时间
                long millis = Calendar.getInstance().getTimeInMillis();
                //如果当前时间-最新上报数据的时间<设置关机范围，那么直接给
                if ((millis - time) < jugeTime && !ObjectUtils.isEmpty(objectList)) {
                    JSONObject jsonObject = objectList.get(0);
                    if(!EmptyUtil.isEmpty(map)){
                        map.putAll(jsonObject.toJavaObject(Map.class));
                    }else{
                        map = jsonObject.toJavaObject(Map.class);
                    }
                }
            } catch (Exception e) {
                return map;
            }
        }
        return map;
    }

    /**
     * 机器人测试
     */
    public Map<String, Object> jqrSendString( Map<String,Map<String,Object>> map,Map<String, Object> objectMap,long millis,
                                              Map<String, Object> reportDto) {
        Map<String, Object> mongoMap = findMongo(map);
        mongoMap.putAll(objectMap);
        mongoMap.remove("_id");
        mongoMap.remove("time");
         millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, Object>> allDto = new ArrayList<>();
        for (Map.Entry<String,Object> entry : mongoMap.entrySet()) {
            Map<String, Object> sites = new HashMap<>();

            try {
                sites.put(entry.getKey(), entry.getValue());
                sites.put("ts", millis);
                allDto.add(sites);
            } catch (Exception e) {
                System.out.println(e);
                Map<String, Object> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", millis);
                allDto.add(site);
                reportDto.put("reported", allDto);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", allDto);

        JSONObject jsonObj=new JSONObject(reportDto);
        String s = jsonObj.toString();
        System.out.println("輸出Json:"+s);
        return reportDto;
    }
}
