package com.jln.system.web.action.mqtt.controller;


import com.jln.common.RedisUtil.RedisUtil;
import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.entity.Result;
import com.jln.system.web.action.mqtt.MqttStartClient;
import com.jln.system.web.action.mqtt.init.InitHander;
import com.jln.system.web.action.mqtt.mapper.ScadaBiMapper;
import com.jln.system.web.action.mqtt.mapper.ScadaTxsbMapper;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import com.jln.system.web.action.mqtt.pojo.vo.StaticData;
import com.jln.system.web.action.mqtt.server.SendMqttServer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/mqtt/mqttclient")
@Api(tags = "mqtt连接")
public class MqttClientController {


    @Autowired
    private MqttStartClient mqttStartClient;
    @Autowired
    private ScadaBiMapper scadaMapper;
    @Autowired
    private ScadaTxsbMapper scadaTxsbMapper;

    @Autowired
    private RedisUtil redisUtil;

    @Autowired
    private SendMqttServer sendMqttServer;

    @ApiOperation(value = "mqtt连接发布订阅", notes = "mqtt连接发布订阅")
    @PostMapping(value = "/start",consumes = "multipart/*", headers = "content-type=multipart/form-data")
    @IgnoreUserLoginToken
    public Result start(@RequestParam MultipartFile file) throws IOException {
        InitHander initHander = new InitHander();
        List<JsonDataDto> jsonDataDtoList = initHander.analysisJsonParm(file);
        if(jsonDataDtoList.isEmpty()){
            String initJson = initJson();
            return new Result().toFailure("标准格式:"+initJson);
        }
        sendMqttServer.sendMqtt(jsonDataDtoList);

       /* List<BldzCclmVo> xpjVos = scadaMapper.find("校平机");
        HashMap<String, String> xpjMap = new HashMap<>();
        for (BldzCclmVo xpjVo : xpjVos) {
            if (xpjVo != null) {
                if ("设备状态".equals(xpjVo.getBLmc())) {
                    xpjMap.put("Status", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("报警".equals(xpjVo.getBLmc())) {
                    xpjMap.put("Alarm", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("最大板厚".equals(xpjVo.getBLmc())) {
                    xpjMap.put("MaxThickness", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("最大板宽".equals(xpjVo.getBLmc())) {
                    xpjMap.put("MaxWidth", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("校平速度".equals(xpjVo.getBLmc())) {
                    xpjMap.put("MaxSpeed", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("上辊行程".equals(xpjVo.getBLmc())) {
                    xpjMap.put("RealLength", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("上辊角度".equals(xpjVo.getBLmc())) {
                    xpjMap.put("RealAngle", xpjVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                //xpjMap.put(xpjVo.getBldz(), xpjVo.getCClm().toLowerCase(Locale.ROOT));
            }
        }
        mqttStartClient.xpjStartLj(xpjTxt, xpjTjSk, "xpj", xpjMap, "xpj");*/

       /* List<BldzCclmVo> btVos = scadaMapper.find("奔腾切割机");
        HashMap<String, String> btMap = new HashMap<>();
        for (BldzCclmVo btVo : btVos) {
            if (btVo != null) {
                btMap.put(btVo.getBldz(), btVo.getCClm().toLowerCase(Locale.ROOT));
            }
        }
        mqttStartClient.jgStartLj(btqgjTxt, btqgjSk, "jgqgj", btMap, "jgqgj");*/


        /*List<BldzCclmVo> msr52Vos = scadaMapper.find("梅塞尔52");
        HashMap<String, List<String>> msr52Map = new HashMap<>();
        for (BldzCclmVo msr52Vo : msr52Vos) {
            if (msr52Vo != null) {

                if ("报警1".equals(msr52Vo.getBLmc()) || "报警2".equals(msr52Vo.getBLmc())
                        || "报警3".equals(msr52Vo.getBLmc()) || "报警4".equals(msr52Vo.getBLmc())
                        || "报警5".equals(msr52Vo.getBLmc()) || "报警6".equals(msr52Vo.getBLmc())
                        || "报警7".equals(msr52Vo.getBLmc()) || "报警8".equals(msr52Vo.getBLmc())
                        || "报警9".equals(msr52Vo.getBLmc()) || "报警10".equals(msr52Vo.getBLmc())) {
                    List<String> list = msr52Map.computeIfAbsent("Alarm", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("工作模式".equals(msr52Vo.getBLmc())) {
                    List<String> list = msr52Map.computeIfAbsent("Mode", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }

                if ("绝对坐标X".equals(msr52Vo.getBLmc()) || "绝对坐标Y".equals(msr52Vo.getBLmc())) {
                    List<String> list = msr52Map.computeIfAbsent("AbsPos", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }

                if ("NC程序启动".equals(msr52Vo.getBLmc()) || "NC程序停止".equals(msr52Vo.getBLmc())) {
                    List<String> list = msr52Map.computeIfAbsent("NcStatus", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("当前程序号".equals(msr52Vo.getBLmc())) {
                    List<String> list = msr52Map.computeIfAbsent("CurPgm", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }

                if ("加工时间".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CycSec", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("程序行号".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("PartCnt", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("产量".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CurSeq", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }

                if ("当前程序块".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CurNcBlk", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("切割速度".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutSpeed", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("板材规格".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("PlateType", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }

                if ("切割气体流量".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutGasFlow", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("保护气体流量".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ProGasFlow", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("切割状态开启".equals(msr52Vo.getBLmc()) || "切割状态关闭".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ProGasFlow", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("切割厚度".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutThick", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("引弧时间".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ArcStrikeTime", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("弧压".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ArcVoltage", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("隔缝补偿".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("GapOffset", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }
                if ("工作电流".equals(msr52Vo.getBLmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("Current", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCClm());
                    continue;
                }


            }
        }
        mqttStartClient.msrStartLj(mse52Txt, mse52Sk, "mse52", msr52Map, "mse52");*/

        // mqttStartClient.msr52StartLj(msrqgjTxt, msrqgjSk, "mse53", msr52Map, "mse53");


       /* List<BldzCclmVo> blxVos = scadaMapper.find("板链线");
        HashMap<String, String> blxMap = new HashMap<>();
        for (BldzCclmVo blxVo : blxVos) {
            if (blxVo!=null) {
                if("设备状态".equals(blxVo.getBLmc())){
                    blxMap.put("Status", blxVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if("是否报警".equals(blxVo.getBLmc())){
                    blxMap.put("Alarm", blxVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                //blxMap.put(blxVo.getBldz(), blxVo.getCClm().toLowerCase(Locale.ROOT));
            }
        }
        mqttStartClient.qtxlStartLj(blxTxt, blxjSk, "blx", blxMap, "blx");*/




        /*List<BldzCclmVo> xgjxcVos = scadaMapper.find("小港机行车");
        HashMap<String, String> xgjxcMap = new HashMap<>();
        for (BldzCclmVo xgjxcVo : xgjxcVos) {
            if (xgjxcVo!=null) {
                if("行车运行状态".equals(xgjxcVo.getBLmc())){
                    xgjxcMap.put("Status", xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if("设备故障".equals(xgjxcVo.getBLmc())){
                    xgjxcMap.put("Alarm", xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if("钢板重量".equals(xgjxcVo.getBLmc())){
                    xgjxcMap.put("LiftWeight", xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if("行车z轴当前位置".equals(xgjxcVo.getBLmc())){
                    xgjxcMap.put("LiftHeight", xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if("勾吊速度".equals(xgjxcVo.getBLmc())){
                    xgjxcMap.put("LiftSpeed", xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
                    continue;
                }
               // xgjxcMap.put(xgjxcVo.getBldz(), xgjxcVo.getCClm().toLowerCase(Locale.ROOT));
            }
        }
        mqttStartClient.zlhcStartLj(xgjxcTxt, xgjxcSk, "xgjxc", xgjxcMap, "xgjxc");*/

     /*   List<BldzCclmVo> blxVos = scadaMapper.find("数控龙门铣");
        HashMap<String, List<String>> lmxMap = new HashMap<>();*/
     /*   for (BldzCclmVo blxVo : blxVos) {
            if (blxVo != null) {
                if ("序列号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("SerNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("软件版本".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("nckVer", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("伺服轴数".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Axes", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("主轴数".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("SpinNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("主轴最高转速".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MaxSpeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }

                if ("工作状态".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Status", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("急停".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CncEmg", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("工作模式".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Model", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("轴名称1".equals(blxVo.getBLmc()) || "轴名称2".equals(blxVo.getBLmc()) || "轴名称3".equals(blxVo.getBLmc()) || "轴名称4".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AxisName", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("机械坐标X".equals(blxVo.getBLmc()) || "机械坐标Y".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MachPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("绝对坐标X".equals(blxVo.getBLmc()) || "绝对坐标Y".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("ABSPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("相对坐标X".equals(blxVo.getBLmc()) || "相对坐标Y".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("RelPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("剩余距离".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("RemPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }

                if ("程序运行状态".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("NcStatus", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("主程序号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MainPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("当前程序号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("切削时间".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CycTime", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("加工时间".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("operatingTime", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("程序行号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurSec", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("产量".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Quantity", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("当前程序块".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurNcBlk", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("刀具号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("TCode", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("切削倍率".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("OvFeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("主轴倍率".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("OvSpin", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("切削速度".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("actFeedRate", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("报警数量".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("alarmNums", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("报警类型".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AlarmType", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
                if ("报警号".equals(blxVo.getBLmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AlarmNo", k -> new ArrayList<String>());
                    list.add(blxVo.getCClm());
                    continue;
                }
            }
        }
        mqttStartClient.lmxStartLj( lmxBjxx,"sklmx", lmxMap, "sklmx");*/

        return new Result().toSuccess();
    }


    @ApiOperation(value = "redis查询数据", notes = "redis查询数据  1->板链线  2->奔腾切割机 3->梅塞尔52 4->梅塞尔53 5->小港机行车 6->校平机 7->数控龙门铣 8->400折弯机 9->大件坡口01 10->大件坡口02 其它返回null")
    @GetMapping("/findRedis")
    @IgnoreUserLoginToken
    public Result findRedis(@RequestParam("ID") Integer id) {
        Map<String, Object> list = null;
        if (id.equals(1)) {
//            list = redisUtil.hmget("blx");
            list = StaticData.data.get("blx");
        } else if (id.equals(2)) {
//            list = redisUtil.hmget("jgqgj");
            list = StaticData.data.get("jgqgj");
        } else if (id.equals(3)) {
//            list = redisUtil.hmget("mse52");
            list = StaticData.data.get("mse52");
        } else if (id.equals(4)) {
            // list = redisUtil.hmget("mse53");
            list = StaticData.data.get("mse53");
        } else if (id.equals(5)) {
//            list = redisUtil.hmget("xgjxc");
            list = StaticData.data.get("xgjxc");
        } else if (id.equals(6)) {
//            list = redisUtil.hmget("xpj");
            list = StaticData.data.get("xpj");
        } else if (id.equals(7)) {
//            list = redisUtil.hmget("sklmx");
            list = StaticData.data.get("sklmx");
        } else if (id.equals(8)) {
//            list = redisUtil.hmget("400zwj");
            list = StaticData.data.get("400zwj");
        } else if (id.equals(9)) {
//            list = redisUtil.hmget("djpk01");
            list = StaticData.data.get("djpk01");
        } else if (id.equals(10)) {
//            list = redisUtil.hmget("djpk02");
            list = StaticData.data.get("djpk02");
        }else if (id.equals(11)) {
            list = StaticData.data.get("skpmz");
        }else if(id.equals(12)){
            list = StaticData.data.get("800zwj");
        }
        return new Result().toSuccess(list);
    }

    private String initJson(){
        String jsonStr="[\n" +
                "    {\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "        \"txtFileUrl\":\"\\\\cacert\\\\cjdqzdtqsb1.txt\",\n" +
                "        \"mongdbTableb\":\"chejiashebeibianliang\",\n" +
                "        \"clientUuid\":\"5003820063\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang03\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d141\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"GroupDistr\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang04\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d142\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"SolidFlow\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d143\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"SolidContent\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d144\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"PowTime\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d145\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"Alarm\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d146\",\n" +
                "                            \"fieldDataType\":\"STRING\",\n" +
                "                            \"iotField\":\"AlarmMsg\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d147\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"PaintFlow\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d148\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"PaintValu\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d149\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"Status\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    }\n" +
                "]";
        return jsonStr;
    }

}
