package com.jln.system.web.action.mqtt.init;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import com.jln.system.web.action.mqtt.server.SendMqttServer;
import com.jln.system.web.action.mqtt.util.FlieUrlUtil;
import com.sun.org.apache.bcel.internal.generic.NEW;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

//@Component
public class InitHander implements CommandLineRunner {

    @Autowired
    private SendMqttServer sendMqttServer;


    @Override
    public void run(String... args){
        //List<JsonDataDto> jsonDataDtoList = analysisJsonParm();
        //sendMqttServer.sendMqtt(jsonDataDtoList);

    }
    public List<JsonDataDto> analysisJsonParm(MultipartFile file) throws IOException {

        String jsonStr = FlieUrlUtil.readJsonField(file);
        //String jsonStr = strJson();//模拟数据
        List<JsonDataDto> jsonDataDtoList = new ArrayList<>();
        try{

            List<JSONObject> list = JSONObject.parseObject(JSONArray.parseArray(jsonStr).toString(), List.class);
            list.forEach(j->{
                JsonDataDto jsonDataDto = new JsonDataDto();
                List<JSONObject> mongdbTableList= JSONObject.parseObject(j.getJSONObject("reported").getJSONArray("singleField").toString(), List.class);
                jsonDataDto.setCmdId(j.get("cmdId").toString());
                jsonDataDto.setMongdbTableb(j.get("mongdbTableb").toString());
                jsonDataDto.setSequenceId(Integer.parseInt(j.get("sequenceId").toString()));
                jsonDataDto.setProductKey(j.get("productKey").toString());
                jsonDataDto.setSkurl(j.get("skurl").toString());
                jsonDataDto.setTxtFileUrl(j.get("txtFileUrl").toString());
                jsonDataDto.setClientUuid(j.get("clientUuid").toString());
                Map<String,Map<String,Object>> tableFiels = new HashMap<>();//存储对应的表和对应的字段
                mongdbTableList.forEach(t->{
                    //处理字段
                    Map<String,Object> fields = new HashMap<>();//存储需要查询的表字段
                    String subTable = t.get("subTable").toString();//拿到表名
                    List<JSONObject> feildslist = JSONObject.parseObject(t.getJSONArray("feilds").toString(), List.class);
                    feildslist.forEach(f->{
                        //取出对应的字段和属性
                        String dbField = f.get("dbField").toString();//查询的表字段
                        String iotField = f.get("iotField").toString();//给iot 的字段
                        String fieldDataType = f.get("fieldDataType").toString(); //给iot的属性
                            /*Map<String,Object> objectMap = new HashMap<>();
                            objectMap.put(dbField,iotField);*/
                        fields.put(dbField,iotField);
                    });
                    tableFiels.put(subTable,fields);
                    jsonDataDto.setTableFiels(tableFiels);
                });
                jsonDataDtoList.add(jsonDataDto);
                //查询数据
            });
        }catch (Exception e){
            return jsonDataDtoList;
        }


        return jsonDataDtoList;
    }

    public static void main(String[] args) {
        //analysisJsonParm();
    }
    private static  String strJson (){
        String str ="[\n" +
                "    {\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "\t\t\"txtFileUrl\":\"\\\\cacert\\\\ptjqr1.txt\",\n" +
                "        \"mongdbTableb\":\"zhengchangshujushebei\",\n" +
                "        \"clientUuid\":\"5003820077\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"zhengchangshujushebei01\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d1\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备1IOT1\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d2\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备1IOT2\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"zhengchangshujushebei02\",\n" +
                "                    \"feilds\":[\n" +
                "                      {\n" +
                "                            \"dbField\":\"d51\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备1IOT3\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d52\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备1IOT4\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    },\n" +
                "\t{\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "\t\t\"txtFileUrl\":\"\\\\cacert\\\\sklmx.txt\",\n" +
                "        \"mongdbTableb\":\"chejiashebeibianliang\",\n" +
                "        \"clientUuid\":\"5003820077\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang01\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d11\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备2IOT1\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d2\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备2IOT2\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang02\",\n" +
                "                    \"feilds\":[\n" +
                "                      {\n" +
                "                            \"dbField\":\"d51\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备2IOT4\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d52\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备2IOT5\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    }\n" +
                "]";
        return str;
    }
}
